/*
 * 
 * Code reprit et adapté depuis avidemux
 *
 * FROM:
 * ----
 * (mean <fixounet@free.fr>)
 *
 * TO:
 * --
 * file      : gtkmarkscale.h
 * project   : xcfa
 * with      : Gtk-2
 *
 * copyright : (C) 2003,2004,2005,2006,2007,2008,2009 by Claude Bulin
 *
 * xcfa - GTK+ implementation of the GNU shell command
 * GNU General Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * OLD ADRESS:
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * NEW ADRESS:
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#ifndef __GTK_MARKSCALE_H__
#define __GTK_MARKSCALE_H__


#include <gdk/gdk.h>
#include <gtk/gtkscale.h>
#include <stdint.h>

G_BEGIN_DECLS

#define GTK_TYPE_MARKSCALE            (gtk_markscale_get_type ())
#define GTK_MARKSCALE(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTK_TYPE_MARKSCALE, GtkMarkScale))
#define GTK_MARKSCALE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), GTK_TYPE_MARKSCALE, GtkMarkScaleClass))
#define GTK_IS_MARKSCALE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTK_TYPE_MARKSCALE))
#define GTK_IS_MARKSCALE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GTK_TYPE_MARKSCALE))
#define GTK_MARKSCALE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), GTK_TYPE_MARKSCALE, GtkMarkScaleClass))


typedef struct _GtkMarkScale       GtkMarkScale;
typedef struct _GtkMarkScaleClass  GtkMarkScaleClass;

struct _GtkMarkScale
{
  GtkScale scale;
};

struct _GtkMarkScaleClass
{
  GtkScaleClass parent_class;
};

GType      gtk_markscale_get_type       (void) G_GNUC_CONST;
GtkWidget* gtk_markscale_new            (GtkAdjustment *adjustment);
GtkWidget* gtk_markscale_new_with_range (gdouble min, gdouble max, gdouble step);

void gtk_markscale_set_SecTime (guint Sec);
void gtk_markscale_set_value_A (GtkWidget *widget, gdouble A);
void gtk_markscale_set_value_B (GtkWidget *widget, gdouble B);

gdouble gtk_markscale_get_value_A (void);
gdouble gtk_markscale_get_value_B (void);

G_END_DECLS

#endif /* __GTK_MARKSCALE_H__ */

