/*
 * 
 * Code reprit et adapté depuis avidemux
 *
 * FROM:
 * ----
 * (mean <fixounet@free.fr>)
 *
 * This is for the simulated jog/shuttle control on the main window, but it
 * can also be controlled by jog/shuttle controllers that exist in the
 * physical world (which are handled in ADM_jogshuttle.cpp).
 * 
 * TO:
 * --
 * file      : jogshuttle.h
 * project   : xcfa
 * with      : Gtk-2
 *
 * copyright : (C) 2003,2004,2005,2006,2007,2008,2009 by Claude Bulin
 *
 * xcfa - GTK+ implementation of the GNU shell command
 * GNU General Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * OLD ADRESS:
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * NEW ADRESS:
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 */
 
#ifndef __JOG_SHUTTLE_H__
#define __JOG_SHUTTLE_H__

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define JOG_TYPE_SHUTTLE		(jog_shuttle_get_type ())
#define JOG_SHUTTLE(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), JOG_TYPE_SHUTTLE, JogShuttle))
#define JOG_SHUTTLE_CLASS(obj)		(G_TYPE_CHECK_CLASS_CAST ((obj), JOG_SHUTTLE, JogShuttleClass))
#define JOG_IS_SHUTTLE(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), JOG_TYPE_SHUTTLE))
#define JOG_IS_SHUTTLE_CLASS(obj)	(G_TYPE_CHECK_CLASS_TYPE ((obj), JOG_TYPE_SHUTTLE))
#define JOG_SHUTTLE_GET_CLASS		(G_TYPE_INSTANCE_GET_CLASS ((obj), JOG_TYPE_SHUTTLE, JogShuttleClass))

typedef struct _JogShuttle        JogShuttle;
typedef struct _JogShuttleClass   JogShuttleClass;

struct _JogShuttle
{
	GtkDrawingArea parent;
};

struct _JogShuttleClass
{
	GtkDrawingAreaClass parent_class;
	void (* value_changed) (JogShuttle *wheel);
};

GtkWidget *jog_shuttle_new (void);
gfloat     jog_shuttle_get_value (GtkWidget *wheel);
void       jog_shuttle_set_value (GtkWidget *wheel, gfloat value);

G_END_DECLS

#endif

