 /*
 * file      : prg_install.c
 * project   : xcfa
 * with      : Gtk-2
 *
 * copyright : (C) 2003,2004,2005,2006,2007,2008,2009 by Claude Bulin
 *
 * xcfa - GTK+ implementation of the GNU shell command
 * GNU General Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * OLD ADRESS:
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * NEW ADRESS:
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 */

 /*
http://download.tuxfamily.org/ubunteros/pour_claude/Slack/
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include "support.h"

#include <pthread.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/wait.h>

#include "global.h"
#include "prg_install.h"
#include "prg_init.h"
#include "utils.h"

#include "win_info.h"
#include "win_pulse.h"
#include "poche.h"
#include "info_song.h"
#include "cdtoc.h"
#include "file.h"
#include "cd_audio.h"
#include "options.h"
#include "secu.h"
#include "get.h"



typedef struct {
	
	gboolean      bool_thread_do_install;			/*  */
	guint         handler_do_install;			/*  */
	pthread_t     nmr_tid;					/*  */
	GtkComboBox *Adr_Widget_install;			/*  */
	gint         CodeErreur;				/*  */
	gint         TotalPackageToInstall;			/*  */
	gint         PackageActif;				/*  */
	gchar        StrPass [ 50 ];
	gint         Pass;
	
} VAR_INSTALL;

VAR_INSTALL var_install;



void prginstall_create_debian_sh (FILE *fp, TYPE_PACKAGE Type_Package, gchar *name, gboolean BoolMyServer)
{
	gchar *PtrName = NULL;
	
	fprintf (fp, "test_stop_install\n");
	fprintf (fp, "\n");
	
	fprintf (fp, "#######\n");
	fprintf (fp, "# Creation dossier de download\n");
	fprintf (fp, "#\n");
	fprintf (fp, "mkdir -p %s\n", PATH_DOWNLOAD_TO_XCFA);
	fprintf (fp, "cd %s\n", PATH_DOWNLOAD_TO_XCFA);
	fprintf (fp, "\n");

	fprintf (fp, "#######\n");
	fprintf (fp, "# For trace\n");
	fprintf (fp, "#\n");
	fprintf (fp, "cat > %s <<END\n", TMP_FILE_XCFA_INSTALL);
	/*fprintf (fp, "Download: %s\n", name);*/
	fprintf (fp, "[%d / %d] Download: %s\n", var_install.PackageActif, var_install.TotalPackageToInstall, name);
	fprintf (fp, "END\n");
	fprintf (fp, "\n");

	fprintf (fp, "#######\n");
	fprintf (fp, "# Download\n");
	fprintf (fp, "#\n");

	switch (var_options.Type_Package) {
	case _NONE_ :
		break;
	case _DEBIAN_ :
	fprintf (fp,
	"if (wget --user-agent=\"Mozilla 22.0\" --directory-prefix=/tmp/download_to_xcfa http://download.tuxfamily.org/xcfaudio/convertisseurs/%s)\n", name);
		break;
	case _TGZ_ :
		if (BoolMyServer == TRUE) {
	fprintf (fp,
	"if (wget --user-agent=\"Mozilla 22.0\" --directory-prefix=/tmp/download_to_xcfa http://download.tuxfamily.org/xcfaudio/convertisseurs/%s)\n", name);
		}
		else {
	fprintf (fp,
	"if (wget --user-agent=\"Mozilla 22.0\" --directory-prefix=/tmp/download_to_xcfa http://download.tuxfamily.org/ubunteros/pour_claude/Slack/%s)\n", name);
		}
		break;
	
	case _FPM_ :
		break;
	
	case _RPM_ :
	fprintf (fp,
	"if (wget --user-agent=\"Mozilla 22.0\" --directory-prefix=/tmp/download_to_xcfa http://download.tuxfamily.org/xcfaudio/convertisseurs/%s)\n", name);
		break;
	}

	if ((PtrName = strrchr (name, '/')) != NULL) 
		PtrName ++;
	else	PtrName = name;
	
	fprintf (fp, "then\n");
	fprintf (fp, "	result_install=$?\n");
	fprintf (fp, "else\n");
	fprintf (fp, "	result_install=$?\n");
	fprintf (fp, "fi\n");
	fprintf (fp, "echo \"wget result_install=\"$result_install\n");
	fprintf (fp, "\n");

	fprintf (fp, "test_erreur_install\n");
	fprintf (fp, "\n");

	fprintf (fp, "test_stop_install\n");
	fprintf (fp, "\n");

	fprintf (fp, "#######\n");
	fprintf (fp, "# For trace\n");
	fprintf (fp, "#\n");
	fprintf (fp, "cat > %s <<END\n", TMP_FILE_XCFA_INSTALL);
	/*fprintf (fp, "Installation: %s\n", name);*/
	fprintf (fp, "[%d / %d] Installation: %s\n", var_install.PackageActif, var_install.TotalPackageToInstall, PtrName);
	fprintf (fp, "END\n");
	fprintf (fp, "\n");

	if (Type_Package == _DEBIAN_) {
		if (options_get_administrator_of_packets () == 0) {
			fprintf (fp, "#######\n");
			fprintf (fp, "# Installation du Download\n");
			fprintf (fp, "#\n");
			fprintf (fp, "if (dpkg --unpack ./%s)\n", PtrName);
			fprintf (fp, "then\n");
			fprintf (fp, "	result_install=$?\n");
			fprintf (fp, "else\n");
			fprintf (fp, "	result_install=$?\n");
			fprintf (fp, "fi\n");
			fprintf (fp, "echo \"result_install=\"$result_install\n");
			fprintf (fp, "\n");

			fprintf (fp, "test_erreur_install\n");
			fprintf (fp, "\n");

			fprintf (fp, "#######\n");
			fprintf (fp, "# For trace\n");
			fprintf (fp, "#\n");
			fprintf (fp, "cat > %s <<END\n", TMP_FILE_XCFA_INSTALL);
			/*fprintf (fp, "Complement d'installation: %s\n", name);*/
			fprintf (fp, "[%d / %d] Complement d'installation: %s\n", var_install.PackageActif, var_install.TotalPackageToInstall, PtrName);
			fprintf (fp, "END\n");
			fprintf (fp, "\n");

			fprintf (fp, "#######\n");
			fprintf (fp, "# Complement d'installation\n");
			fprintf (fp, "#\n");

			fprintf (fp, "if (apt-get install -f)\n");
		} else {
			fprintf (fp, "if (aptitude --assume-yes -y install ./%s)\n", PtrName);
		}
	}
	else if (Type_Package == _TGZ_) {
		fprintf (fp, "if installpkg ./%s\n", PtrName);
	}
	else if (Type_Package == _RPM_) {
		fprintf (fp, "if rpm -ivh ./%s\n", PtrName);
	}
	
	fprintf (fp, "then\n");
	fprintf (fp, "	result_install=$?\n");
	fprintf (fp, "else\n");
	fprintf (fp, "	result_install=$?\n");
	fprintf (fp, "fi\n");
	fprintf (fp, "\n");

	fprintf (fp, "test_erreur_install\n");
	fprintf (fp, "\n");
	
	var_install.PackageActif ++;
}

gboolean prginstall_button_create_file_xcfa_clicked (void)
{
	GList    *LList = NULL;
	GList    *list = NULL;
	gchar    *ptr = NULL;
	FILE     *fp = NULL;
	gchar    *LineCommand = NULL;
	gboolean  bool_select = TRUE;

	/* PRINT_FUNC_LF(); */
	
	if ((LList = prginit_get_glist_install (LList)) == NULL) {
		bool_select = FALSE;
	}
	LList = prginit_remove_glist_prog (LList);
	if (bool_select == FALSE) {
		wininfo_create (
			_("Aucune selection  !"),
			_("    Il faut selectionner des fichiers     "),
			  "           \n\n",
			  "");
		return (FALSE);
	}
	
	/* Suppression du fichier precedant si il existe
	*/
	infosong_delete_file (FILE_XCFA_INSTALL);

	fp = fopen (FILE_XCFA_INSTALL, "w");
	if (fp == NULL) {
		g_print ("fp == NULL\n");
		wininfo_create (
			"    Erreur creation: /tmp/xcfa_install.sh    ",
			"    <b><i>Salut,</i></b>,\n\n",
			"    <b>Le fichier '/tmp/xcfa_install.sh' N'a PAS ete cree !!</b>    \n",
			"           \n\n",
			"");
		return (FALSE);
	}
	
	/* Chercher le nombre total de fichier a installer
	*/
	var_install.TotalPackageToInstall = 0;
	var_install.PackageActif = 1;
	if ((LList = prginit_get_glist_install (LList)) != NULL) {
	
		list = g_list_first (LList);
		while (list) {
			if ((ptr = (gchar *)list->data)) {
				if (strcmp (ptr, "mac") == 0) {
					switch (var_options.Type_Package) {
					case _NONE_   : break;
					case _DEBIAN_ :
					case _TGZ_    :
					case _RPM_    :
					case _FPM_    :
						var_install.TotalPackageToInstall ++;
						break;
					}
				}
				else if (strcmp (ptr, "shorten") == 0) {
					switch (var_options.Type_Package) {
					case _NONE_   : break;
					case _DEBIAN_ :
					case _TGZ_    :
					case _RPM_    :
					case _FPM_    :
						var_install.TotalPackageToInstall ++;
						break;
					}
				}
				else if (strcmp (ptr, "musepack-decoder") == 0) {
					switch (var_options.Type_Package) {
					case _NONE_   : break;
					case _DEBIAN_ :
					case _TGZ_    :
					case _RPM_    :
					case _FPM_    :
						var_install.TotalPackageToInstall ++;
						break;
					}
				}
				else if (HostConf.BoolCpuIs64Bits == FALSE && strcmp (ptr, "musepack-encoder") == 0) {
					switch (var_options.Type_Package) {
					case _NONE_   : break;
					case _DEBIAN_ :
					case _TGZ_    :
					case _RPM_    :
					case _FPM_    :
						var_install.TotalPackageToInstall ++;
						break;
					}
				}
				else {
					switch (var_options.Type_Package) {
					case _NONE_   :
					case _TGZ_    :
					case _RPM_    :
					case _FPM_    :
						break;
					case _DEBIAN_ :
						var_install.TotalPackageToInstall ++;
						break;
					}
				}
			}
			list = g_list_next (list);
		}
		LList = prginit_remove_glist_prog (LList);
	}
	
	/* Entete
	*/
	fprintf (fp, "#!/bin/sh\n");
	/*fprintf (fp, "#!/bin/bash\n");*/
	fprintf (fp, "\n");
	fprintf (fp, "set -e\n");
	fprintf (fp, "\n");

	/* Description
	*/
	switch (var_options.Type_Package) {
	case _NONE_ :
		break;
		
	case _DEBIAN_ :
		fprintf (fp, "##\n");
		fprintf (fp, "##  INSTALLATION DES PAQUETS DEBIAN POUR XCFA\n");
		fprintf (fp, "##  INSTALLATION OF PACKAGES DEBIAN FOR XCFA \n");
		fprintf (fp, "##\n");
		break;
		
	case _TGZ_ :
		fprintf (fp, "##\n");
		fprintf (fp, "##  INSTALLATION DES PAQUETS TGZ POUR XCFA\n");
		fprintf (fp, "##  INSTALLATION OF PACKAGES TGZ FOR XCFA \n");
		fprintf (fp, "##\n");
		break;
		
	case _FPM_ :
		break;

	case _RPM_ :
		fprintf (fp, "##\n");
		fprintf (fp, "##  INSTALLATION DES PAQUETS RPM POUR XCFA\n");
		fprintf (fp, "##  INSTALLATION OF PACKAGES RPM FOR XCFA \n");
		fprintf (fp, "##\n");
		break;
	}

	fprintf (fp, "\n");
	fprintf (fp, "#\n");
	fprintf (fp, "# If mode is not in Super-User, quit\n");
	fprintf (fp, "#\n");
	fprintf (fp, "if [ `id -u` -ne 0 ]\n");
	fprintf (fp, "then\n");
	fprintf (fp, "	echo\n");
	fprintf (fp, "	echo \"Please change to Super-User to continue this installion \"\n");
	fprintf (fp, "	echo \"Utilisez le mode Super-Utilisateur pour continuer cette installation \"\n");
	fprintf (fp, "	echo\n");
	fprintf (fp, "	exit 1\n");
	fprintf (fp, "fi\n");
	fprintf (fp, "\n");
	
	fprintf (fp, "test_stop_install ()\n");
	fprintf (fp, "{\n");
	fprintf (fp, "	if (test -e /tmp/STOP_INSTALL)\n");
	fprintf (fp, "	then\n");
	fprintf (fp, "		echo \"ARRET INSTALLATION PAR UTILISATEUR\";\n");
	fprintf (fp, "		rm -f /tmp/ERROR_INSTALL;\n");
	fprintf (fp, "		rm -rf %s;\n", PATH_DOWNLOAD_TO_XCFA);
	fprintf (fp, "		rm -f %s;\n", TMP_FILE_XCFA_INSTALL);
	fprintf (fp, "		rm -f /tmp/STOP_INSTALL;\n");
	fprintf (fp, "		exit 3;\n");
	fprintf (fp, "	fi\n");
	fprintf (fp, "}\n");
	fprintf (fp, "\n");
	
	fprintf (fp, "test_erreur_install ()\n");
	fprintf (fp, "{\n");
	fprintf (fp, "	if [ \"$result_install\" != \"0\" ]\n");
	fprintf (fp, "	then\n");
	fprintf (fp, "		echo \"PROBLEME A l'INSTALLATION: exit 3;\"\n");
	fprintf (fp, "#		touch /tmp/ERROR_INSTALL;\n");
	fprintf (fp, "#		rm -rf %s;\n", PATH_DOWNLOAD_TO_XCFA);
	fprintf (fp, "#		rm -f %s;\n", TMP_FILE_XCFA_INSTALL);
	fprintf (fp, "#		rm -f /tmp/STOP_INSTALL;\n");
	fprintf (fp, "#		exit 3;\n");
	fprintf (fp, "	fi\n");
	fprintf (fp, "}\n");	
	fprintf (fp, "\n");

	fprintf (fp, "#######\n");
	fprintf (fp, "# Supprimer la trace d'erreur et le dossier de download\n");
	fprintf (fp, "#\n");
	fprintf (fp, "rm -f /tmp/ERROR_INSTALL\n");
	fprintf (fp, "rm -rf %s\n", PATH_DOWNLOAD_TO_XCFA);
	fprintf (fp, "rm -f %s\n",TMP_FILE_XCFA_INSTALL);
	fprintf (fp, "rm -f /tmp/STOP_INSTALL\n");
	fprintf (fp, "\n");

	if (var_options.Type_Package == _DEBIAN_) {
		fprintf (fp, "#######\n");
		fprintf (fp, "# For trace\n");
		fprintf (fp, "#\n");
		fprintf (fp, "cat > %s <<END\n", TMP_FILE_XCFA_INSTALL);
		fprintf (fp, "Update ...\n");
		fprintf (fp, "END\n");
		fprintf (fp, "\n");

		fprintf (fp, "#######\n");
		fprintf (fp, "# Cherche le code de retour pour \"apt-get update\"\n");
		fprintf (fp, "#\n");
		
		if (options_get_administrator_of_packets () == 0) {
			fprintf (fp, "if (apt-get update)\n");
		} else {
			fprintf (fp, "if (aptitude update)\n");
		}
		
		fprintf (fp, "then\n");
		fprintf (fp, "	result_update=$?\n");
		fprintf (fp, "else\n");
		fprintf (fp, "	result_update=$?\n");
		fprintf (fp, "fi\n");
		fprintf (fp, "echo \"result_update=\"$result_update\n");
		fprintf (fp, "\n");
	}
	else {
		fprintf (fp, "result_update=0\n\n");
	}
	
	/* Parcours de la liste des fichiers en selection
	*/
	if ((LList = prginit_get_glist_install (LList)) != NULL) {
	
		list = g_list_first (LList);
		while (list) {
			if ((ptr = (gchar *)list->data)) {
				
				if (strcmp (ptr, "mac") == 0) {
					if (HostConf.BoolCpuIs64Bits == TRUE) {
						/*
						switch (var_options.Type_Package) {
						case _NONE_   : break;
						case _DEBIAN_ : prginstall_create_debian_sh (fp, _DEBIAN_, "mac_3.99-3_amd64.deb", TRUE); break;
						case _TGZ_    : prginstall_create_debian_sh (fp, _TGZ_,    "mac-3.99.tgz", TRUE); break;
						case _RPM_    : prginstall_create_debian_sh (fp, _RPM_,    "mac-3.99-2.u4b5.fc7.x86_64.rpm", TRUE); break;
						*/
						switch (var_options.Type_Package) {
						case _NONE_   : break;
						case _DEBIAN_ : prginstall_create_debian_sh (fp, _DEBIAN_, "amd64/Deb/mac_3.99-4_amd64.deb", TRUE); break;
						case _TGZ_    : prginstall_create_debian_sh (fp, _TGZ_,    "amd64/Tgz/mac-3.99_amd64.tgz", TRUE); break;
						case _RPM_    : prginstall_create_debian_sh (fp, _RPM_,    "amd64/Rpm/mac-3.99-5.amd64.rpm", TRUE); break;
						case _FPM_    : break;
						}
					}
					else {
						/*
						switch (var_options.Type_Package) {
						case _NONE_   : break;
						case _DEBIAN_ : prginstall_create_debian_sh (fp, _DEBIAN_, "mac_3.99_i386.deb", TRUE); break;
						case _TGZ_    : prginstall_create_debian_sh (fp, _TGZ_,    "mac-3.99-u4.tgz", TRUE); break;
						case _RPM_    : prginstall_create_debian_sh (fp, _RPM_,    "mac-3.99_u4-1.i386.rpm", TRUE); break;
						*/
						switch (var_options.Type_Package) {
						case _NONE_   : break;
						case _DEBIAN_ : prginstall_create_debian_sh (fp, _DEBIAN_, "i386/Deb/mac_3.99-4_i386.deb", TRUE); break;
						case _TGZ_    : prginstall_create_debian_sh (fp, _TGZ_,    "i386/Tgz/mac-3.99_i386.tgz", TRUE); break;
						case _RPM_    : prginstall_create_debian_sh (fp, _RPM_,    "i386/Rpm/mac-3.99-5.i386.rpm", TRUE); break;
						case _FPM_    : break;
						}
					}
				}
				else if (strcmp (ptr, "shorten") == 0) {
					if (HostConf.BoolCpuIs64Bits == TRUE) {
						switch (var_options.Type_Package) {
						case _NONE_   : break;
						/*
						case _DEBIAN_ : prginstall_create_debian_sh (fp, _DEBIAN_,"shorten_3.6.1-1_amd64.deb", TRUE); break;
						case _TGZ_    : prginstall_create_debian_sh (fp, _TGZ_,   "shorten-3.6.1.tgz", TRUE); break;
						case _RPM_    : prginstall_create_debian_sh (fp, _RPM_,   "shorten-3.6.1-2.x86_64.rpm", TRUE);  break;
						*/
						case _DEBIAN_ : prginstall_create_debian_sh (fp, _DEBIAN_,"amd64/Deb/shorten_3.6.1-1_amd64.deb", TRUE); break;
						case _TGZ_    : prginstall_create_debian_sh (fp, _TGZ_,   "amd64/Tgz/shorten-3.6.1_amd64.tgz", TRUE); break;
						case _RPM_    : prginstall_create_debian_sh (fp, _RPM_,   "amd64/Rpm/shorten-3.6.1-2.amd64.rpm", TRUE); break;
						case _FPM_    : break;
						}
					}
					else {
						switch (var_options.Type_Package) {
						case _NONE_   : break;
						/*
						case _DEBIAN_ : prginstall_create_debian_sh (fp, _DEBIAN_,"shorten_3.6.0-1_i386.deb", TRUE); break;
						case _TGZ_    : prginstall_create_debian_sh (fp, _TGZ_,   "shorten-3.6.0.tgz", TRUE); break;
						case _RPM_    : prginstall_create_debian_sh (fp, _RPM_,   "shorten-3.6.0-2.i386.rpm", TRUE);  break;
						*/
						case _DEBIAN_ : prginstall_create_debian_sh (fp, _DEBIAN_,"i386/Deb/shorten_3.6.0-1_i386.deb", TRUE); break;
						case _TGZ_    : prginstall_create_debian_sh (fp, _TGZ_,   "i386/Tgz/shorten-3.6.0_i386.tgz", TRUE); break;
						case _RPM_    : prginstall_create_debian_sh (fp, _RPM_,   "i386/Rpm/shorten-3.6.0-2.i386.rpm", TRUE); break;
						case _FPM_    : break;
						}
					}
				}
				else if (strcmp (ptr, "musepack-decoder") == 0) {
					switch (var_options.Type_Package) {
					case _NONE_   : break;
					/*
					case _DEBIAN_ : prginstall_create_debian_sh (fp, _DEBIAN_,"musepack-decoder_7.1.95z67-2_i386.deb", TRUE); break;
					case _TGZ_    : prginstall_create_debian_sh (fp, _TGZ_,"musepack-decoder-7.1.95z67.tgz", TRUE); break;
					case _RPM_    : prginstall_create_debian_sh (fp, _RPM_,"musepack-decoder-7.1.95z67-3.i386.rpm", TRUE); break;
					*/
					case _DEBIAN_ : prginstall_create_debian_sh (fp, _DEBIAN_,"i386/Deb/musepack-decoder_7.1.95z67-2_i386.deb", TRUE); break;
					case _TGZ_    : prginstall_create_debian_sh (fp, _TGZ_,   "i386/Tgz/musepack-decoder-7.1.95z67_i386.tgz", TRUE); break;
					case _RPM_    : prginstall_create_debian_sh (fp, _RPM_,   "i386/Rpm/musepack-decoder-7.1.95z67-3.i386.rpm", TRUE); break;
					case _FPM_    : break;
					}
				}
				/*else if (HostConf.BoolCpuIs64Bits == FALSE && strcmp (ptr, "musepack-encoder") == 0) {*/
				else if (strcmp (ptr, "musepack-encoder") == 0) {
					/*
					switch (var_options.Type_Package) {
					case _NONE_   : break;
					case _DEBIAN_ : prginstall_create_debian_sh (fp, _DEBIAN_,"mppenc_1.16-2_i386.deb", TRUE); break;
					case _TGZ_    : prginstall_create_debian_sh (fp, _TGZ_,"mppenc-1.16.tgz", TRUE); break;
					case _RPM_    : prginstall_create_debian_sh (fp, _RPM_,"mppenc-1.16-3.i386.rpm", TRUE); break;
					}
					*/
					
					if (HostConf.BoolCpuIs64Bits == TRUE) {
						switch (var_options.Type_Package) {
						case _NONE_   : break;
						case _DEBIAN_ : prginstall_create_debian_sh (fp, _DEBIAN_,"amd64/Deb/mppenc_1.16-4_amd64.deb", TRUE); break;
						case _TGZ_    : prginstall_create_debian_sh (fp, _TGZ_,   "amd64/Tgz/mppenc-1.16_amd64.tgz", TRUE); break;
						case _RPM_    : prginstall_create_debian_sh (fp, _RPM_,   "amd64/Rpm/mppenc-1.16-5.amd64.rpm", TRUE); break;
						case _FPM_    : break;
						}
					}
					else {
						switch (var_options.Type_Package) {
						case _NONE_   : break;
						case _DEBIAN_ : prginstall_create_debian_sh (fp, _DEBIAN_,"i386/Deb/mppenc_1.16-4_i386.deb", TRUE); break;
						case _TGZ_    : prginstall_create_debian_sh (fp, _TGZ_,   "i386/Tgz/mppenc-1.16_i386.tgz", TRUE); break;
						case _RPM_    : prginstall_create_debian_sh (fp, _RPM_,   "i386/Rpm/mppenc-1.16-5.i386.rpm", TRUE); break;
						case _FPM_    : break;
						}
					}
				}
				else {
					switch (var_options.Type_Package) {
					case _NONE_   : break;
					case _DEBIAN_ : 

						fprintf (fp, "test_stop_install\n");
						fprintf (fp, "\n");

						fprintf (fp, "#######\n");
						fprintf (fp, "# For trace\n");
						fprintf (fp, "#\n");
						fprintf (fp, "cat > %s <<END\n", TMP_FILE_XCFA_INSTALL);
						/*fprintf (fp, "%s\n", ptr);*/
						fprintf (fp, "[%d / %d] %s\n", var_install.PackageActif, var_install.TotalPackageToInstall, ptr);
						fprintf (fp, "END\n");
						fprintf (fp, "\n");
						
						fprintf (fp, "#######\n");
						fprintf (fp, "# Installation de %s\n", ptr);
						fprintf (fp, "#\n");
						
						if (options_get_administrator_of_packets () == 0) {
							fprintf (fp, "if (apt-get --force-yes -y install %s)\n", ptr);
						}
						else {
							fprintf (fp, "if (aptitude --assume-yes -y install %s)\n", ptr);
						}

						fprintf (fp, "then\n");
						fprintf (fp, "	result_install=$?\n");
						fprintf (fp, "else\n");
						fprintf (fp, "	result_install=$?\n");
						fprintf (fp, "fi\n");
						fprintf (fp, "echo \"result_install=\"$result_install\n");
						fprintf (fp, "\n");

						fprintf (fp, "test_erreur_install\n");
						fprintf (fp, "\n");
						
						var_install.PackageActif ++;
						break;
					/*
					flac123-0.0.11-i486-1bj.tgz
					lsdvd-0.16-i486-1mfb.tgz
					mpg321-0.2.10-i486-2.tgz
					normalize-0.7.6-i486-1.tgz
					sox-12.18.1-i486-1.tgz
					wavpack-4.41.0-i486-1bj.tgz
					oggutils-1.0rc3-i386-1.tgz
					vorbis-tools
					*/
					case _TGZ_    :
						if (strcmp (ptr, "flac123") == 0) {
							prginstall_create_debian_sh (fp, _TGZ_,"flac123-0.0.11-i486-1bj.tgz", FALSE);
						}
						else if (strcmp (ptr, "lsdvd") == 0) {
							prginstall_create_debian_sh (fp, _TGZ_,"lsdvd-0.16-i486-1mfb.tgz", FALSE);
						}
						else if (strcmp (ptr, "mpg321") == 0) {
							prginstall_create_debian_sh (fp, _TGZ_,"mpg321-0.2.10-i486-2.tgz", FALSE);
						}
						else if (strcmp (ptr, "normalize") == 0) {
							prginstall_create_debian_sh (fp, _TGZ_,"normalize-0.7.6-i486-1.tgz", FALSE);
						}
						else if (strcmp (ptr, "sox") == 0) {
							prginstall_create_debian_sh (fp, _TGZ_,"sox-12.18.1-i486-1.tgz", FALSE);
						}
						else if (strcmp (ptr, "wavpack") == 0) {
							prginstall_create_debian_sh (fp, _TGZ_,"wavpack-4.41.0-i486-1bj.tgz", FALSE);
						}
						else if (strcmp (ptr, "vorbis-tools") == 0) {
							prginstall_create_debian_sh (fp, _TGZ_,"oggutils-1.0rc3-i386-1.tgz", FALSE);
						}
						else if (strcmp (ptr, "checkmp3") == 0) {
							prginstall_create_debian_sh (fp, _TGZ_,"mp3_check-1.98-i486-48.1.tgz", FALSE);
						}
						break;
					case _RPM_    :
						
						/*
						RPM amd64
						
						checkmp3-1.98-8.amd64.rpm
						mp3gain-1.4.6-8.amd64.rpm
						mp3splt-2.1-2.1.amd64.rpm
						mpc123-0.2.2-2.amd64.rpm
						mpg321-0.2.10.4-2.amd64.rpm
						vorbisgain-0.36-4.amd64.rpm
						wavsplit-1.1.0-4.amd64.rpm
						
						RPM i386
						
						checkmp3-1.98-8.i386.rpm
						mp3gain-1.4.6-8.i386.rpm
						mp3splt-2.1c-5.i386.rpm
						mpc123-0.2.4-2.i386.rpm
						mpg321-0.2.10.4-2.i386.rpm
						vorbisgain-0.36-4.i386.rpm
						wavsplit-1.1.0-4.i386.rpm
						*/
						if (strcmp (ptr, "checkmp3") == 0) {
							if (HostConf.BoolCpuIs64Bits == TRUE)
								prginstall_create_debian_sh (fp, _RPM_,"amd64/Rpm/checkmp3-1.98-8.amd64.rpm", FALSE);
							else	prginstall_create_debian_sh (fp, _RPM_,"i386/Rpm/checkmp3-1.98-8.i386.rpm", FALSE);
						}
						else if (strcmp (ptr, "mp3gain") == 0) {
							if (HostConf.BoolCpuIs64Bits == TRUE)
								prginstall_create_debian_sh (fp, _RPM_,"amd64/Rpm/mp3gain-1.4.6-8.amd64.rpm", FALSE);
							else	prginstall_create_debian_sh (fp, _RPM_,"i386/Rpm/mp3gain-1.4.6-8.i386.rpm", FALSE);
						}
						else if (strcmp (ptr, "mp3splt") == 0) {
							if (HostConf.BoolCpuIs64Bits == TRUE)
								prginstall_create_debian_sh (fp, _RPM_,"amd64/Rpm/mp3splt-2.1-2.1.amd64.rpm", FALSE);
							else	prginstall_create_debian_sh (fp, _RPM_,"i386/Rpm/mp3splt-2.1c-5.i386.rpm", FALSE);
						}
						else if (strcmp (ptr, "mpc123") == 0) {
							if (HostConf.BoolCpuIs64Bits == TRUE)
								prginstall_create_debian_sh (fp, _RPM_,"amd64/Rpm/mpc123-0.2.2-2.amd64.rpm", FALSE);
							else	prginstall_create_debian_sh (fp, _RPM_,"i386/Rpm/mpc123-0.2.4-2.i386.rpm", FALSE);
						}
						else if (strcmp (ptr, "mpg321") == 0) {
							if (HostConf.BoolCpuIs64Bits == TRUE)
								prginstall_create_debian_sh (fp, _RPM_,"amd64/Rpm/mpg321-0.2.10.4-2.amd64.rpm", FALSE);
							else	prginstall_create_debian_sh (fp, _RPM_,"i386/Rpm/mpg321-0.2.10.4-2.i386.rpm", FALSE);
						}
						else if (strcmp (ptr, "vorbisgain") == 0) {
							if (HostConf.BoolCpuIs64Bits == TRUE)
								prginstall_create_debian_sh (fp, _RPM_,"amd64/Rpm/vorbisgain-0.36-4.amd64.rpm", FALSE);
							else	prginstall_create_debian_sh (fp, _RPM_,"i386/Rpm/vorbisgain-0.36-4.i386.rpm", FALSE);
						}
						else if (strcmp (ptr, "wavsplit") == 0) {
							if (HostConf.BoolCpuIs64Bits == TRUE)
								prginstall_create_debian_sh (fp, _RPM_,"amd64/Rpm/wavsplit-1.1.0-4.amd64.rpm", FALSE);
							else	prginstall_create_debian_sh (fp, _RPM_,"i386/Rpm/wavsplit-1.1.0-4.i386.rpm", FALSE);
						}
						
						/* openSUSE
						*/
						else if (utils_scan_by_which ("zypper", NULL) == TRUE) {

							fprintf (fp, "test_stop_install\n");
							fprintf (fp, "\n");

							fprintf (fp, "#######\n");
							fprintf (fp, "# For trace\n");
							fprintf (fp, "#\n");
							fprintf (fp, "cat > %s <<END\n", TMP_FILE_XCFA_INSTALL);
							/*fprintf (fp, "%s\n", ptr);*/
							fprintf (fp, "[%d / %d] %s\n", var_install.PackageActif, var_install.TotalPackageToInstall, ptr);
							fprintf (fp, "END\n");
							fprintf (fp, "\n");
							
							fprintf (fp, "#######\n");
							fprintf (fp, "# Installation de %s\n", ptr);
							fprintf (fp, "#\n");
							
							fprintf (fp, "if (zypper install -y %s)\n", ptr);

							fprintf (fp, "then\n");
							fprintf (fp, "	result_install=$?\n");
							fprintf (fp, "else\n");
							fprintf (fp, "	result_install=$?\n");
							fprintf (fp, "fi\n");
							fprintf (fp, "echo \"result_install=\"$result_install\n");
							fprintf (fp, "\n");

							fprintf (fp, "test_erreur_install\n");
							fprintf (fp, "\n");
							
							var_install.PackageActif ++;
						}
						
						/* Fedora
						*/
						else if (utils_scan_by_which ("yum", NULL) == TRUE) {

							fprintf (fp, "test_stop_install\n");
							fprintf (fp, "\n");

							fprintf (fp, "#######\n");
							fprintf (fp, "# For trace\n");
							fprintf (fp, "#\n");
							fprintf (fp, "cat > %s <<END\n", TMP_FILE_XCFA_INSTALL);
							/*fprintf (fp, "%s\n", ptr);*/
							fprintf (fp, "[%d / %d] %s\n", var_install.PackageActif, var_install.TotalPackageToInstall, ptr);
							fprintf (fp, "END\n");
							fprintf (fp, "\n");
							
							fprintf (fp, "#######\n");
							fprintf (fp, "# Installation de %s\n", ptr);
							fprintf (fp, "#\n");
							
							fprintf (fp, "if (yum install %s)\n", ptr);

							fprintf (fp, "then\n");
							fprintf (fp, "	result_install=$?\n");
							fprintf (fp, "else\n");
							fprintf (fp, "	result_install=$?\n");
							fprintf (fp, "fi\n");
							fprintf (fp, "echo \"result_install=\"$result_install\n");
							fprintf (fp, "\n");

							fprintf (fp, "test_erreur_install\n");
							fprintf (fp, "\n");
							
							var_install.PackageActif ++;
						}
						
						/* RPM AUTRES SYSTEMES
						*/
						else {
							/*
							sudo rpm -ivh
							*/
						}
						
						break;
						
					case _FPM_    : break;
					}
				}
			}
			list = g_list_next (list);
		}
		LList = prginit_remove_glist_prog (LList);
	}
	
	fprintf (fp, "#######\n");
	fprintf (fp, "# Nettoyage\n");
	fprintf (fp, "#\n");
	fprintf (fp, "rm -rf %s\n", PATH_DOWNLOAD_TO_XCFA);
	fprintf (fp, "rm -f /tmp/ERROR_INSTALL\n");
	fprintf (fp, "rm -f %s\n",TMP_FILE_XCFA_INSTALL);
	fprintf (fp, "rm -f /tmp/STOP_INSTALL\n");
	fprintf (fp, "\n\n");
	fprintf (fp, "exit 0\n");
	fprintf (fp, "\n");
	
	fclose (fp);

	LineCommand = g_strdup_printf ("chmod +x %s", FILE_XCFA_INSTALL);
	system (LineCommand);
	g_free (LineCommand);
	LineCommand = NULL;

	return (TRUE);
}

gint prginstall_in_super_user (void)
{
	return (get_in_super_user ());
}


static void prginstall_do_thread (void *arg)
{
	var_install.bool_thread_do_install = TRUE;
	
	/* Creation du fichier: /tmp/xcfa_install.sh */
	/* if (prginstall_button_create_file_xcfa_clicked ()) {*/
		/* Installation */
		var_install.CodeErreur = prginstall_in_super_user ();
	/* }*/
	
	var_install.bool_thread_do_install = FALSE;
	pthread_exit (0);
}


static gint prginstall_do_timeout (gpointer data)
{
	/*
	if (winpulse_event_set_close ()) {
		if (infosong_file_is_reg ("/tmp/STOP_INSTALL") == FALSE) {
			FILE *fp = NULL;
			fp = fopen ("/tmp/STOP_INSTALL", "a");
			fclose (fp);
		}
	}
	*/
	if (var_install.bool_thread_do_install == FALSE) {
		
		/* Scan pour prise en compte par Xcfa*/
		prginit_update_glist ();

		/* Close window */
		winpulse_close ();
		
		/* if (var_install.CodeErreur != 0) { */
		if (infosong_file_is_reg ("/tmp/ERROR_INSTALL")) {
			
			wininfo_create (
				_("        ERREUR PENDANT L'INSTALLATION        "),
				  "\n",
				_("   Un autre gestionnaire de paquage est probablement actif   "),
				  "\n",
				_("   OU"),
				  "\n",
				_("   La connexion internet est mauvaise"),
				  "\n",
				_("   OU"),
				  "\n",
				_("   Aucun depot pour cette application"),
				  "           \n\n",
				  "");
		}
		
		/* Suppression du fichier bash d'installation */
		infosong_delete_file (FILE_XCFA_INSTALL);

		gtk_widget_set_sensitive (GTK_WIDGET (var_prgextern.button_goto_install), prginit_get_bool_install ());
		gtk_widget_set_sensitive (GTK_WIDGET (var_prgextern.button_selection_globale), prginit_is_not_installed ());

		/* end of timeout */
		gtk_timeout_remove (var_install.handler_do_install);
	}
	else {
   		gchar *spinner="|/-\\";
		
		var_install.StrPass [ 24 ] = spinner[ var_install.Pass ++ % 4 ];
		var_install.StrPass [ 25 ] = '\0';
		winpulse_set_labelfile (var_install.StrPass);
		/*
		FILE   *fp = NULL;
		gchar   buf [ 60 ];
		gchar  *str = NULL;
		gint    i;
		
		for (i=0; i < 60; i++) buf [ i ] = '\0';
		buf [ 0 ] = '\0';
		if ((fp = fopen (TMP_FILE_XCFA_INSTALL, "r"))) {
			fgets (buf, 49, fp);
			fclose (fp);
			for (i=0; i < 60; i++)
				if (buf [ i ] == '\0') {
					g_print("------------------i = %d\n", i);
					break;
				}
		
			if (buf [ 0 ] != '\0') {
				if ((str = strchr (buf, '\n'))) *str = '\0';
				str = NULL;
				str = g_strdup_printf ("%s ...", buf);
				winpulse_set_labelfile (str);
				g_free (str);
				str = NULL;
			}
		}
		*/
		if (winpulse_event_set_close ()) {
			if (infosong_file_is_reg ("/tmp/STOP_INSTALL") == FALSE) {
				FILE *fp = NULL;
				fp = fopen ("/tmp/STOP_INSTALL", "a");
				fclose (fp);
			}
		}
	}
	
	return (TRUE);
}

gboolean prginstall_test_in_super_user (void)
{
	if (utils_scan_by_which (GK_SUDO, NULL) == TRUE) {
		return (TRUE);
	}
	else if (utils_scan_by_which (KDE_SUDO, NULL) == TRUE) {
		return (TRUE);
	}
	else if (utils_scan_by_which (RPM_SUDO, NULL) == TRUE) {
		return (TRUE);
	}
	wininfo_create (
		_("      kdesu et/ou gksu ABSENTS    "),
		  "\n",
		_("   Veuillez installer kdesu et/ou gksu"),
		  "           \n\n",
		  "");
	return  (FALSE);
}

void prginstall_packages (void)
{
	/* Test l'intallation en SuperUtilisateur est ok */
	if (prginstall_test_in_super_user () == TRUE) {	

		if (prginstall_button_create_file_xcfa_clicked ()) {
			
			/* Attente */
			winpulse_create ();
			winpulse_set_title ("Installation automatique");
			winpulse_set_init_pulse ();
			winpulse_set_labeltitle ("Installation automatique");
			winpulse_set_labelfile ("Veuillez patienter ...");
			
			var_install.Pass = -1;
			strcpy (var_install.StrPass, "Veuillez patienter ...:   ");
			
			/* Thread & Timeout */
			var_install.bool_thread_do_install = TRUE;
			pthread_create (&var_install.nmr_tid, NULL ,(void *)prginstall_do_thread, (void *)NULL);
			var_install.handler_do_install = gtk_timeout_add (100, prginstall_do_timeout, 0);
		}
	}
}

void prginstall_set_label_type_package (GtkWidget *widget)
{
	gchar *New_Str = NULL;
	
	var_options.Adr_label_type_paquege = widget;
	
	if (utils_scan_by_which ("apt-get", NULL) == TRUE || utils_scan_by_which ("aptitude", NULL) == TRUE) {
		if (widget != NULL) {
			New_Str = g_strdup_printf (" <b>... les paquets: deb</b> ");
			gtk_label_set_markup (GTK_LABEL (var_options.Adr_label_type_paquege), New_Str);
			gtk_label_set_markup (GTK_LABEL (GTK_WIDGET (lookup_widget (wind_main, "label_type_package_without_deb"))), New_Str);
			g_free (New_Str);
			New_Str = NULL;
		}
		var_options.Type_Package = _DEBIAN_;
	}
	else if (utils_scan_by_which ("slackpkg", NULL) == TRUE || utils_scan_by_which ("installpkg", NULL) == TRUE) {
		if (widget != NULL) {
			New_Str = g_strdup_printf (" <b>... les paquets: tgz</b> ");
			gtk_label_set_markup (GTK_LABEL (var_options.Adr_label_type_paquege), New_Str);
			gtk_label_set_markup (GTK_LABEL (GTK_WIDGET (lookup_widget (wind_main, "label_type_package_without_deb"))), New_Str);
			g_free (New_Str);
			New_Str = NULL;
		}
		var_options.Type_Package = _TGZ_;
	}
	else if (utils_scan_by_which ("pacman-g2", NULL) == TRUE) {
		if (widget != NULL) {
			New_Str = g_strdup_printf (" <b>... les paquets: fpm</b> ");
			gtk_label_set_markup (GTK_LABEL (var_options.Adr_label_type_paquege), New_Str);
			gtk_label_set_markup (GTK_LABEL (GTK_WIDGET (lookup_widget (wind_main, "label_type_package_without_deb"))), New_Str);
			g_free (New_Str);
			New_Str = NULL;
		}
		var_options.Type_Package = _FPM_;
	}
	else if (utils_scan_by_which ("rpm", NULL) == TRUE || utils_scan_by_which ("urpmi", NULL) == TRUE  || utils_scan_by_which ("zypper", NULL) == TRUE || utils_scan_by_which ("yum", NULL) == TRUE) {
		if (widget != NULL) {
			New_Str = g_strdup_printf (" <b>... les paquets: rpm</b> ");
			gtk_label_set_markup (GTK_LABEL (var_options.Adr_label_type_paquege), New_Str);
			gtk_label_set_markup (GTK_LABEL (GTK_WIDGET (lookup_widget (wind_main, "label_type_package_without_deb"))), New_Str);
			g_free (New_Str);
			New_Str = NULL;
		}
		var_options.Type_Package = _RPM_;
	}
	

}
/*
void OLD_prginstall_set_label_type_package (GtkWidget *widget)
{
	gchar *New_Str = NULL;
	
	var_options.Adr_label_type_paquege = widget;
	
	if (infosong_file_is_reg ("/var/lib/rpm/Basenames") &&
	    infosong_file_is_reg ("/var/lib/rpm/Conflictname") &&
	    infosong_file_is_reg ("/var/lib/rpm/Group")) {
		
		if (widget != NULL) {
			New_Str = g_strdup_printf (" <b>... les paquets: rpm</b> ");
			gtk_label_set_markup (GTK_LABEL (var_options.Adr_label_type_paquege), New_Str);
			gtk_label_set_markup (GTK_LABEL (GTK_WIDGET (lookup_widget (wind_main, "label_type_package_without_deb"))), New_Str);
			g_free (New_Str);
			New_Str = NULL;
		}
		var_options.Type_Package = _RPM_;
	}
	else if (infosong_file_is_reg ("/etc/apt/sources.list")) {
		if (widget != NULL) {
			New_Str = g_strdup_printf (" <b>... les paquets: deb</b> ");
			gtk_label_set_markup (GTK_LABEL (var_options.Adr_label_type_paquege), New_Str);
			gtk_label_set_markup (GTK_LABEL (GTK_WIDGET (lookup_widget (wind_main, "label_type_package_without_deb"))), New_Str);
			g_free (New_Str);
			New_Str = NULL;
		}
		var_options.Type_Package = _DEBIAN_;
	}
	else {
		if (widget != NULL) {
			New_Str = g_strdup_printf (" <b>... les paquets: tgz</b> ");
			gtk_label_set_markup (GTK_LABEL (var_options.Adr_label_type_paquege), New_Str);
			gtk_label_set_markup (GTK_LABEL (GTK_WIDGET (lookup_widget (wind_main, "label_type_package_without_deb"))), New_Str);
			g_free (New_Str);
			New_Str = NULL;
		}
		var_options.Type_Package = _TGZ_;
	}
}
*/

TYPE_PACKAGE prginstall_get_label_type_package (void)
{
	var_options.Type_Package = _NONE_;

	if (utils_scan_by_which ("apt-get", NULL) == TRUE || utils_scan_by_which ("aptitude", NULL) == TRUE) {
		var_options.Type_Package = _DEBIAN_;
	}
	else if (utils_scan_by_which ("slackpkg", NULL) == TRUE || utils_scan_by_which ("installpkg", NULL) == TRUE) {
		var_options.Type_Package = _TGZ_;
	}
	else if (utils_scan_by_which ("pacman-g2", NULL) == TRUE) {
		var_options.Type_Package = _FPM_;
	}
	else if (utils_scan_by_which ("rpm", NULL) == TRUE || utils_scan_by_which ("urpmi", NULL) == TRUE  || utils_scan_by_which ("zypper", NULL) == TRUE || utils_scan_by_which ("yum", NULL) == TRUE) {
		var_options.Type_Package = _RPM_;
	}
	return (var_options.Type_Package);
}
/*
TYPE_PACKAGE OLD_prginstall_get_label_type_package (void)
{
	var_options.Type_Package = _NONE_;

	if (infosong_file_is_reg ("/var/lib/rpm/Basenames") &&
	    infosong_file_is_reg ("/var/lib/rpm/Conflictname") &&
	    infosong_file_is_reg ("/var/lib/rpm/Group")) {
		
		var_options.Type_Package = _RPM_;
	}
	else if (infosong_file_is_reg ("/etc/apt/sources.list")) {
		
		var_options.Type_Package = _DEBIAN_;
	}
	else if (utils_scan_by_which ("installpkg", NULL)) {
		
		var_options.Type_Package = _TGZ_;
	}
	return (var_options.Type_Package);
}
*/
void prginstall_combobox_installation_realize (GtkWidget *widget)
{
	
	/* PRINT_FUNC_LF(); */

	prginstall_set_label_type_package (var_options.Adr_label_type_paquege);

	utils_clear_elements_combobox (widget);
	
	switch (var_options.Type_Package) {

	case _NONE_:
		break;
		
	case _DEBIAN_ :
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "Choix : Pour paquages Deb");
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "   Selection globale + Installation + Scan");
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "   (Selection partielle) + Installation + Scan");
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "   ---");	
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "   Selection globale");
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "   Deselection globale");
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "   Creation de: /tmp/xcfa_install.sh");
		break;

	case _TGZ_ :
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "Choix : Pour paquages Tgz");
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "   Selection globale");
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "   Deselection globale");
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "   Creation de: /tmp/xcfa_install.sh");
		break;

	case _RPM_ :
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "Choix : Pour paquages Rpm");
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "   Selection globale");
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "   Deselection globale");
		gtk_combo_box_append_text (GTK_COMBO_BOX (widget), "   Creation de: /tmp/xcfa_install.sh");
		break;
		
	case _FPM_ :
		break;
	}
	
	
	gtk_combo_box_set_active (GTK_COMBO_BOX (widget), 0);
	var_install.Adr_Widget_install = GTK_COMBO_BOX (widget);
	
}

void prginstall_systeme_debian (gint value)
{
	/*
	Choix :-- Deb
	   Selection globale + Installation + Scan
	   (Selection partielle) + Installation + Scan
	   ---
	   Selection globale
	   Deselection globale
	   Creation de: /tmp/xcfa_install.sh
	*/
	switch (value) {
	
	case 1 :
		/* Selectionne tous les programmes absents */
		if (prginit_set_selected () == FALSE) {
			wininfo_create (
				_("      Aucun logiciel externe a installer    "),
				  "           \n\n",
				  "");
			return;
		}
		
		prginstall_packages ();
		break;
		
	case 2 :
		if (prginit_is_selected () == FALSE) {
						
			wininfo_create (
				_("   (Selection partielle) + Installation + Scan      "),
				  "        Il faut au moins selectionner un programme !!!\n"
				  "           \n",
				  "");		
			return;
		}
		
		prginstall_packages ();
		break;
	case 3 :
	
		/* --- */
		break;
	
	case 4 :
		/* Selectionne tous les programmes absents */
		if (prginit_set_selected () == FALSE) {
			wininfo_create (
				_("      Aucun logiciel externe a selectionner    "),
				  "           \n",
				  "");
		}
		break;
	
	case 5:
		/*prginit_set_Deselected ();*/
		break;
		
	case 6 :
		if (prginit_is_selected () == FALSE) {
			wininfo_create (
				_("   Creation de: /tmp/xcfa_install.sh      "),
				  "        Il faut au moins selectionner un programme !!!     \n"
				  "           \n",
				  "");
			return;
		}

		/* Creation du fichier: /tmp/xcfa_install.sh */
		if (prginstall_button_create_file_xcfa_clicked () == TRUE) {
			if (infosong_file_is_reg ("/tmp/xcfa_install.sh")) {
				wininfo_create (
					_("   Creation de: /tmp/xcfa_install.sh      "),
					  "        Vous pouvez maintenant activer en mode 'root'        \n"
					  "        ce fichier pour installer les programmes\n"
					  "        absents.\n"
					  "           \n",
					  "");
			}
		}
		break;
	}
}
void prginstall_systeme_tgz (gint value)
{
	/*
	Choix :--
	   Selection globale
	   Deselection globale
	   Creation de: /tmp/xcfa_install.sh
	*/
	switch (value) {
	case 1 :
		if (prginit_set_selected () == FALSE) {
			wininfo_create (
				_("      Aucun logiciel externe a selectionner    "),
				  "           \n",
				  "");
		}
		break;
	case 2 :
		/*prginit_set_Deselected ();*/
		break;
	case 3 :
		if (prginit_is_selected () == FALSE) {
			wininfo_create (
				_("   Creation de: /tmp/xcfa_install.sh      "),
				  "        Il faut au moins selectionner un programme !!!     \n"
				  "           \n",
				  "");
			return;
		}
		
		/* Creation du fichier: /tmp/xcfa_install.sh */
		if (prginstall_button_create_file_xcfa_clicked () == TRUE) {
			if (infosong_file_is_reg ("/tmp/xcfa_install.sh")) {
				wininfo_create (
					_("   Creation de: /tmp/xcfa_install.sh      "),
					  "        Vous pouvez maintenant activer en mode 'root'        \n"
					  "        ce fichier pour installer les programmes\n"
					  "        absents.\n"
					  "           \n",
					  "");
			}
		}
		break;
	}
}
void prginstall_systeme_rpm (gint value)
{
	/*
	Choix :--
	   Selection globale
	   Deselection globale
	   Creation de: /tmp/xcfa_install.sh
	*/
	switch (value) {
	case 1 :
		if (prginit_set_selected () == FALSE) {
			wininfo_create (
				_("      Aucun logiciel externe a selectionner    "),
				  "           \n",
				  "");
		}
		break;
	case 2 :
		/*prginit_set_Deselected ();*/
		break;
	case 3 :
		if (prginit_is_selected () == FALSE) {
			wininfo_create (
				_("   Creation de: /tmp/xcfa_install.sh      "),
				  "        Il faut au moins selectionner un programme !!!     \n"
				  "           \n",
				  "");
			return;	
		}
		
		/* Creation du fichier: /tmp/xcfa_install.sh */
		if (prginstall_button_create_file_xcfa_clicked () == TRUE) {
			if (infosong_file_is_reg ("/tmp/xcfa_install.sh")) {
				wininfo_create (
					_("   Creation de: /tmp/xcfa_install.sh      "),
					  "        Vous pouvez maintenant activer en mode 'root'        \n"
					  "        ce fichier pour installer les programmes\n"
					  "        absents.\n"
					  "           \n",
					  "");
			}
		}
		break;
	}
}

void prginstall_combobox_installation_changed (void)
{
	gint value;
PRINT("Ce comboBox ne sera plus necessaire ...");
return;
	if (var_install.Adr_Widget_install == NULL) return;

	var_install.CodeErreur = 0;
	value = gtk_combo_box_get_active (var_install.Adr_Widget_install);
	gtk_combo_box_set_active (GTK_COMBO_BOX (var_install.Adr_Widget_install), 0);

	switch (var_options.Type_Package) {

	case _NONE_:
		break;
		
	case _DEBIAN_ :
		prginstall_systeme_debian (value);
		break;

	case _TGZ_ :
		prginstall_systeme_tgz (value);
		break;

	case _RPM_ :
		prginstall_systeme_rpm (value);
		break;
	
	case _FPM_ :
		break;
	}
}

