 /*
 * file    : tags.h
 * project : xcfa
 * with    : Gtk-2
 *
 * xcfa - GTK+ implementation of the GNU shell command
 * GNU General Public License
 * 2003,2004,2005,2006,2007,2008,2009 Claude Bulin
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * OLD ADRESS:
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * NEW ADRESS:
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 */



#ifndef __tags_h__
#define __tags_h__ 1


#include "file.h"


/*
*---------------------------------------------------------------------------
* TAGS.C
*---------------------------------------------------------------------------
*/

TAGS     *tags_alloc (gboolean bool_tag_cd);
TAGS     *tags_remove (TAGS *tags);
TAGS     *tags_set (gchar *filename, TAGS *tags);
void      tags_set_flag_modification (TAGS *tags, gboolean p_flag);
gboolean  tags_is_modified (TAGS *tags);
gchar    *tags_get_time (gchar *namefile);
gchar    *tags_get_time_wav (gchar *namefile);

/*
*---------------------------------------------------------------------------
* TAGS_WAV.C
*---------------------------------------------------------------------------
*/
INFO_WAV *tagswav_remove_info (INFO_WAV *info);
INFO_WAV *tagswav_get_info (DETAIL *detail, gchar *namefile);
gboolean  tagswav_file_is_wav (gchar *namefile);
gboolean  tagswav_file_is_mono (gchar *namefile);

/*
*---------------------------------------------------------------------------
* TAGS_FLAC.C
*---------------------------------------------------------------------------
*/
INFO_FLAC *tagsflac_remove_info (INFO_FLAC *info);
INFO_FLAC *tagsflac_get_info (DETAIL *detail, gchar *namefile);
gboolean   tagsflac_file_is_flac (gchar *namefile);

/*
*---------------------------------------------------------------------------
* TAGS_MP3.C
*---------------------------------------------------------------------------
*/
INFO_MP3 *tagsmp3_remove_info (INFO_MP3 *info);
INFO_MP3 *tagsmp3_get_info (DETAIL *detail, gchar *namefile);
gboolean  tagsmp3_file_is_mp3 (gchar *namefile);

/*
*---------------------------------------------------------------------------
* TAGS_OGG.C
*---------------------------------------------------------------------------
*/
INFO_OGG *tagsogg_remove_info (INFO_OGG *info);
INFO_OGG *tagsogg_get_info (DETAIL *detail, gchar *namefile);
gboolean  tagsogg_file_is_ogg (gchar *namefile);

/*
*---------------------------------------------------------------------------
* TAGS_M4A_.C
*---------------------------------------------------------------------------
*/
INFO_M4A *tagsm4a_remove_info (INFO_M4A *info);
INFO_M4A *tagsm4a_get_info (DETAIL *detail, gchar *namefile);


/*
*---------------------------------------------------------------------------
* TAGS_AAC_.C
*---------------------------------------------------------------------------
*/
INFO_AAC *tagsaac_remove_info (INFO_AAC *info);

/*
*---------------------------------------------------------------------------
* TAGS_SHN.C
*---------------------------------------------------------------------------
*/
gboolean  tagsshn_file_is_shn (gchar *namefile);
INFO_SHN *tagsshn_remove_info (INFO_SHN *info);
INFO_SHN *tagsshn_get_info (gchar *namefile);

/*
*---------------------------------------------------------------------------
* TAGS_WMA.C
*---------------------------------------------------------------------------
*/
INFO_WMA *tagswma_remove_info (INFO_WMA *info);
INFO_WMA *tagswma_get_info (gchar *namefile);

/*
*---------------------------------------------------------------------------
* TAGS_MPC.C
*---------------------------------------------------------------------------
*/
gboolean  tagsmpc_file_is_mpc (gchar *namefile);
INFO_MPC *tagsmpc_remove_info (INFO_MPC *info);
INFO_MPC *tagsmpc_get_info (gchar *namefile);

/*
*---------------------------------------------------------------------------
* TAGS_APE.C
*---------------------------------------------------------------------------
*/
gboolean  tagsape_file_is_ape (gchar *namefile);
INFO_APE *tagsape_remove_info (INFO_APE *info);
INFO_APE *tagsape_get_info (gchar *namefile);

/*
*---------------------------------------------------------------------------
* TAGS_WAVPACK.C
*---------------------------------------------------------------------------
*/
gboolean      tagswavpack_file_is_wavpack (gchar *namefile);
INFO_WAVPACK *tagswavpack_remove_info (INFO_WAVPACK *info);
INFO_WAVPACK *tagswavpack_get_info (DETAIL *detail, gchar *namefile);

#endif


